﻿// BS"D
// Split Table Before
// An InDesign script by Ariel Walden.
// Copyright (c) 2022, Bookraft LLC
// For more InDesign scripts, please visit www.id-extras.com

var theScriptName = "Split Table Before";
app.doScript(main, undefined, undefined, UndoModes.ENTIRE_SCRIPT, theScriptName);

function main(){
	var theTable, theRow, s;
	s = "Please place the cursor in a table cell and try again. The table will be split, with the selected row becoming the first row of the new table.";
	if (app.selection.length === 0){
		alert(s, theScriptName);
		return;
	}
	theTable = app.selection[0];
	while (theTable instanceof Table === false && theTable instanceof Application === false){
		if (theTable instanceof Row){
			theRow = theTable;
		}
		if (theTable instanceof Cell){
			theRow = theTable.rows[0];
		}
		theTable = theTable.parent;
	}
	if (theTable instanceof Table === false || theRow instanceof Row === false){
		alert(s, theScriptName);
		return;
	}
	splitTable(theTable, theRow);
}

function splitTable(t, r){
	var rowIndex, t2, theOffset, theChar;
	rowIndex = r.index;
	if (rowIndex === 0){
		return;
	}
	theOffset = t.storyOffset;
	theChar = theOffset.parentStory.characters[theOffset.index];
	t2 = theChar.duplicate(LocationOptions.BEFORE, theChar).tables[0];
	t2.rows.itemByRange(rowIndex, t.rows.length - 1).remove();
	t.rows.itemByRange(0, rowIndex - 1).remove();
}
	
	